package{
  import flash.display.BitmapData;

//--------------------------------------------------------------------//
// tBONX
  public class Morph extends Deform{

    public function Morph():void{
    }

//--------------------------------------------------------------------//
// 摜
// image - 摜`悷摜
// t - }p[^ (0 ` 1 ͈̔)
// morphImg1,morphImg2 - C[W1,2
    public override function getPixel(image:BitmapData,t:Number,
      	      	      	      	      morphImg1:MorphImage,
      	      	      	      	      morphImg2:MorphImage):void{
      super.getPixel(image,t,morphImg1,morphImg2);

      image.lock();
      image.fillRect(image.rect,bgColor);
      var figureHeight:Number=Math.max(morphImg1.figureHeight,
      	      	      	      	       morphImg2.figureHeight);
      var ddy1:Number=Number(morphImg1.figureHeight)/figureHeight;
      var ddy2:Number=Number(morphImg2.figureHeight)/figureHeight;

      for(var j:int=0;j<figureHeight;j++){
      	var dy1:Number=ddy1*j;
      	var dy2:Number=ddy2*j;
      	var j1:int=int(dy1);
      	var j2:int=int(dy2);
      	var y1:int=morphImg1.figureY[j1];
      	var y2:int=morphImg2.figureY[j2];
      	dy1+=Number(y1-j1);
      	dy2+=Number(y2-j2);
      	var y:int=inter(t,dy1,dy2);
      	var dx:Number=Math.max(morphImg1.figureWidth[y1],
      	      	      	       morphImg2.figureWidth[y2]);
      	var ddx1:Number=Number(morphImg1.figureWidth[y1])/dx;
      	var ddx2:Number=Number(morphImg2.figureWidth[y2])/dx;
      	for(var i:int=0;i<dx;i++){
      	  var dx1:Number=ddx1*i;
      	  var dx2:Number=ddx2*i;
      	  var i1:int=int(dx1);
      	  var i2:int=int(dx2);
      	  var x1:int=morphImg1.figureX[i1][y1];
      	  var x2:int=morphImg2.figureX[i2][y2];
      	  dx1+=Number(x1-i1);
      	  dx2+=Number(x2-i2);
      	  var x:int=inter(t,dx1,dx2);
      	  image.setPixel(x,y,mixedColor(t,morphImg1.pixel(x1,y1),
      	      	      	      	      	morphImg2.pixel(x2,y2)));
      	}
      }
      image.unlock();
    }
  }
}
