package{
  import flash.display.BitmapData;

//--------------------------------------------------------------------//
// ό`C[WNX
  public class MorphImage{

// 摜f[^
    public var image:BitmapData;

// ό`ΏۂxW
    public var figureX:Array;

// ό`ΏۂyW
    public var figureY:Vector.<int>;

// ό`Ώۂ̕
    public var figureWidth:Vector.<int>;

// ό`Ώۂ̍
    public var figureHeight:int;

// wiF
    public var bgColor:uint;

//--------------------------------------------------------------------//
// ό`C[W\z
// image - 摜
// threshold - wiF臒l
    public function MorphImage(image:BitmapData,threshold:int):void{
      this.image=image;
      init(threshold);
    }

//--------------------------------------------------------------------//
// sNZf[^
// threshold - wiF臒l
    protected function init(threshold:int):void{
      figureX=new Array(image.width+1);
      for(var i:int=0;i<image.width;i++){
      	figureX[i]=new Vector.<int>(image.height);
      }

      figureY=new Vector.<int>(image.height+1,true);
      figureWidth=new Vector.<int>(image.height,true);

      var thres2:int=threshold*threshold;
      bgColor=image.getPixel(0,0);
      figureHeight=0;
      for(var j:int=0;j<image.height;j++){
      	var ii:int=0;
      	for(i=0;i<image.width;i++){
      	  var color:uint=image.getPixel(i,j);
      	  var dr:int=(0xFF&(color>>16))-(0xFF&(bgColor>>16));
      	  var dg:int=(0xFF&(color>>8))-(0xFF&(bgColor>>8));
      	  var db:int=(0xFF&color)-(0xFF&bgColor);
      	  var dist:int=dr*dr+dg*dg+db*db;
      	  if(dist>=thres2){
      	    figureX[ii][j]=i;
      	    ii++;
      	  }
      	}
      	if(ii!=0){
      	  figureY[figureHeight]=j;
      	  figureHeight++;
      	  figureX[ii][j]=figureX[ii-1][j]+1;
      	}
      	figureWidth[j]=ii;
      }
      figureY[figureHeight]=figureY[figureHeight-1]+1;
    }

//--------------------------------------------------------------------//
// C[W̕Ԃ
    public function getWidth():int{
      return image.width;
    }

//--------------------------------------------------------------------//
// C[W̍Ԃ
    public function getHeight():int{
      return image.height;
    }

//--------------------------------------------------------------------//
// sNZf[^Ԃ
// x,y - W
    public function pixel(x:int,y:int):uint{
      return image.getPixel(x,y);
    }
  }
}
