package{
  import flash.display.Sprite;
  import flash.display.Bitmap;
  import flash.display.BitmapData;
  import flash.events.Event;
  import flash.events.TimerEvent;
  import flash.utils.Timer;

  [SWF(width="240",height="180",backgroundColor="0x000000")]

//--------------------------------------------------------------------//
// tBO CNX
  public class Morphing extends Sprite{

// 摜ǂݍ݃[_[
    internal var loader:ImagesLoader;

// 摜̐
    protected var imageCount:int;

// 摜̃Xg
    internal var ming:Vector.<MorphImage>;

// ό`IuWFNg
    internal var deform:Deform;

// ʕ\摜
    internal var image:Bitmap;

// ^C}[
    internal var timer:Timer;

// ݂̃Xebv
    internal var time:int;

// ό`OC[W̃|C^
    internal var image1:int;

// ό`C[W̃|C^
    internal var image2:int;

// 1Xebv̎ (~b)
    internal var dtime:int;

// ό`̊Ԃ̑҂Xebv
    internal var waitStep:int;

// ό`̃Xebv
    internal var step:int;

// wiF臒l
    internal var threshold:int;

//--------------------------------------------------------------------//
    public function Morphing(){
      var vars:Object=loaderInfo.parameters; // html ̎擾p[^

      image1=0;
      image2=1;
      var waitTime:int=vars["waitTime"];
      var morphTime:int=vars["morphTime"];
      step=vars["step"];
      threshold=vars["threshold"];
      dtime=morphTime/step;
      waitStep=waitTime/dtime;
      var deformType:String=String(vars["MDswitch"]).toLowerCase();
      if(deformType=="dissolving"){
      	deform=new Dissolve();
      }
      else{
      	deform=new Morph();
      }

      imageCount=0;
      var url:Vector.<String>=new Vector.<String>(2,false);
      var name:String=null;
      do{
      	name=vars["image"+(imageCount+1)];
      	if(name!=null){
      	  url[imageCount]=name;
      	  imageCount++;
      	}
      }while(name!=null);

      ming=new Vector.<MorphImage>(imageCount,true);
      loader=new ImagesLoader(url);
      loader.addEventListener(ImagesLoader.LOAD_COMPLETE,onImagesLoaded);

    }

//--------------------------------------------------------------------//
// 摜ǂݍ݊
    private function onImagesLoaded(event:Event):void{
      var width:Number=0.0;
      var height:Number=0.0;
      for(var i:int=0;i<imageCount;i++){
      	ming[i]=new MorphImage(loader.data[i],threshold);
      	width=Math.max(width,ming[i].image.width);
      	height=Math.max(height,ming[i].image.height);
      }

      image=new Bitmap();
      image.bitmapData=new BitmapData(width,height,false);
      addChild(image);
      time=0;
      timer=new Timer(dtime);
      timer.addEventListener(TimerEvent.TIMER,run);
      timer.start();
    }

//--------------------------------------------------------------------//
// ^C}[s
    public function run(event:TimerEvent):void{
      time++;
      if(time<=step){
      	deform.getPixel(image.bitmapData,Number(time)/Number(step),
      	      	      	ming[image1],ming[image2]);
      }
      else if(time==step+waitStep){
      	if(imageCount>=2){
      	  image1=(image1+1)%imageCount;
      	  image2=(image2+1)%imageCount;
      	}
      	time=0;
      }
    }
  }
}